#ifndef _LCD_H_
#define _LCD_H_

#include "stdint.h"
#include "variants.h"

#ifdef STM32_HAS_FSMC

  typedef struct
  {
    volatile uint16_t LCD_REG;
    volatile uint16_t LCD_RAM;
  } LCD_TypeDef;
                                
  #define LCD_BASE        ((uint32_t)(0x60000000 | 0x00FFFFFE))  	//1111 1111 1111 1111 1111 1110	
  #define LCD             ((LCD_TypeDef *) LCD_BASE)

  #define LCD_WR_REG(regval) do{ LCD->LCD_REG = regval; }while(0)
  #define LCD_WR_DATA(data)  do{ LCD->LCD_RAM = data; }while(0)
  
#else
  #error "don't support LCD-GPIO yet"  
#endif


//

#define WHITE                 0xFFFF
#define BLACK                 0x0000    
#define BLUE                  0x001F  
#define BRED                  0XF81F
#define GRED                  0XFFE0
#define GBLUE                 0X07FF
#define RED                   0xF800
#define MAGENTA               0xF81F
#define GREEN                 0x07E0
#define CYAN                  0x7FFF
#define YELLOW                0xFFE0
#define BROWN                 0XBC40 //
#define BRRED                 0XFC07 //
#define GRAY                  0X8430 //

void LCD_HardwareConfig(void);
uint16_t LCD_RD_DATA(void);

#endif
